darcs-2.12.5: a distributed, interactive, smart revision control system

Safe Haskell | None
Language | Haskell2010

Darcs.Patch.Prim.FileUUID.Core

# Documentation

data Prim wX wY where #

Constructors

BinaryHunk :: !UUID -> Hunk wX wY -> Prim wX wY |
TextHunk :: !UUID -> Hunk wX wY -> Prim wX wY |
Manifest :: !UUID -> Location -> Prim wX wY |
Demanifest :: !UUID -> Location -> Prim wX wY |
Move :: !UUID -> Location -> Location -> Prim wX wY |
Identity :: Prim wX wX |

Instances

Show2 Prim # |
Methods showDict2 :: ShowDict (Prim wX wY) #
MyEq Prim # |
Methods unsafeCompare :: Prim wA wB -> Prim wC wD -> Bool # (=\/=) :: Prim wA wB -> Prim wA wC -> EqCheck wB wC # (=/\=) :: Prim wA wC -> Prim wB wC -> EqCheck wA wB #
PatchInspect Prim # |
Methods listTouchedFiles :: Prim wX wY -> [FilePath] # hunkMatches :: (ByteString -> Bool) -> Prim wX wY -> Bool #
Invert Prim # |
Methods invert :: Prim wX wY -> Prim wY wX #
IsHunk Prim # |
Methods isHunk :: Prim wX wY -> Maybe (FileHunk wX wY) #
PrimConstruct Prim # |
Methods addfile :: FilePath -> Prim wX wY # rmfile :: FilePath -> Prim wX wY # adddir :: FilePath -> Prim wX wY # rmdir :: FilePath -> Prim wX wY # move :: FilePath -> FilePath -> Prim wX wY # changepref :: String -> String -> String -> Prim wX wY # hunk :: FilePath -> Int -> [ByteString] -> [ByteString] -> Prim wX wY # tokreplace :: FilePath -> String -> String -> String -> Prim wX wY # binary :: FilePath -> ByteString -> ByteString -> Prim wX wY # primFromHunk :: FileHunk wX wY -> Prim wX wY # anIdentity :: Prim wX wX #
PrimClassify Prim # |
Methods primIsAddfile :: Prim wX wY -> Bool # primIsRmfile :: Prim wX wY -> Bool # primIsAdddir :: Prim wX wY -> Bool # primIsRmdir :: Prim wX wY -> Bool # primIsMove :: Prim wX wY -> Bool # primIsHunk :: Prim wX wY -> Bool # primIsTokReplace :: Prim wX wY -> Bool # primIsBinary :: Prim wX wY -> Bool # primIsSetpref :: Prim wX wY -> Bool # is_filepatch :: Prim wX wY -> Maybe FileName #
Show1 (Prim wX) # |
Methods showDict1 :: ShowDict (Prim wX wX) #
Eq (Prim wX wY) # |
Methods (==) :: Prim wX wY -> Prim wX wY -> Bool # (/=) :: Prim wX wY -> Prim wX wY -> Bool #
Show (Prim wX wY) # |
Methods showsPrec :: Int -> Prim wX wY -> ShowS # show :: Prim wX wY -> String # showList :: [Prim wX wY] -> ShowS #
type ApplyState Prim # |
type ApplyState Prim = ObjectMap
type PrimOf Prim # |
type PrimOf Prim = Prim

data Hunk wX wY where #

Constructors

Hunk :: !Int -> ByteString -> ByteString -> Hunk wX wY |

Instances

Show2 Hunk # |
Methods showDict2 :: ShowDict (Hunk wX wY) #
MyEq Hunk # |
Methods unsafeCompare :: Hunk wA wB -> Hunk wC wD -> Bool # (=\/=) :: Hunk wA wB -> Hunk wA wC -> EqCheck wB wC # (=/\=) :: Hunk wA wC -> Hunk wB wC -> EqCheck wA wB #
Show1 (Hunk wX) # |
Methods showDict1 :: ShowDict (Hunk wX wX) #
Show (Hunk wX wY) # |
Methods showsPrec :: Int -> Hunk wX wY -> ShowS # show :: Hunk wX wY -> String # showList :: [Hunk wX wY] -> ShowS #

newtype UUID #

Constructors

UUID ByteString |

Instances

Eq UUID # |
Methods (==) :: UUID -> UUID -> Bool # (/=) :: UUID -> UUID -> Bool #
Ord UUID # |
Methods compare :: UUID -> UUID -> Ordering # (<) :: UUID -> UUID -> Bool # (<=) :: UUID -> UUID -> Bool # (>) :: UUID -> UUID -> Bool # (>=) :: UUID -> UUID -> Bool # max :: UUID -> UUID -> UUID # min :: UUID -> UUID -> UUID #
Show UUID # |
Methods showsPrec :: Int -> UUID -> ShowS # show :: UUID -> String # showList :: [UUID] -> ShowS #

type Location = (UUID, ByteString) #

data Object m #

Constructors

Directory DirContent |
Blob (m ByteString) !Hash |

touches :: Prim wX wY -> [UUID] #

hunkEdit :: Hunk wX wY -> ByteString -> ByteString #